--[[
Copyright 2008, 2009, 2010, 2011 João Libório Cardoso
Scrap is distributed under the terms of the GNU General Public License (or the Lesser GPL).
This file is part of Scrap.

Scrap is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Scrap is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Scrap. If not, see <http://www.gnu.org/licenses/>.
--]]

local VERSION = 1
if not Scrap_List or (Scrap_UpdaterVersion and Scrap_UpdaterVersion >= VERSION) then
	return
else
	Scrap_UpdaterVersion = VERSION
end

local IsJunk = Scrap.IsJunk
Scrap.IsJunk = function() return nil end

StaticPopupDialogs['SCRAP_UPDATER_LOADING'] = {
	text = "Scrap junk list is being updated for this character.\nMeanwhile, Scrap will be disabled and won't detect or sell any junk.",
	button1 = OKAY,
	hideOnEscape = 1,
	showAlertGear = 1,
	exclusive = 1,
	whileDead = 1,
	timeout = 0
}

StaticPopupDialogs['SCRAP_UPDATER_DONE'] = {
	text = "Scrap junk list has been updated for this character.\nIt is adviced for you to run this update once in every character you use Scrap with.",
	button1 = OKAY,
	hideOnEscape = 1,
	exclusive = 1,
	whileDead = 1,
	timeout = 0
}
StaticPopup_Show('SCRAP_UPDATER_LOADING')

local function updateList()
	wipe(Scrap_Junk)
	wipe(Scrap_NotJunk)

	for itemID in pairs(Scrap_List) do
		local value = select(11, GetItemInfo(itemID))
		if value > 0 then
			if IsJunk(Scrap, itemID) then
				Scrap_NotJunk[itemID] = true -- has the list is not being used, the values are switched out
			else
				Scrap_Junk[itemID] = true
			end
		end
	end
	
	StaticPopup_Hide('SCRAP_UPDATER_LOADING')
	StaticPopup_Show('SCRAP_UPDATER_DONE')
	Scrap.IsJunk = IsJunk
end

local query = CreateFrame('Frame')
query:SetScript('OnUpdate', function()
	for itemID in pairs(Scrap_List) do
		if not GetItemInfo(itemID) then
			return
		end
	end
	
	query:SetScript('OnUpdate', nil)
	updateList()
end)